



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#学习笔记之结构体</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#学习笔记之结构体</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 23:17:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.概述</strong></p>
<p>结构是一种与类相似的数据类型，不过它较类更为轻量，一般适用于表示类似Point、Rectangle、Color的对象。基本上结构能办到的类全都能办到，但在某些情况下使用结构更为合适，后面会有提到。</p>
<p>结构具有以下特点：</p>
<ul><li>结构可以实现接口。</li>
<li>结构可以声明带参数的构造函数。</li>
<li>结构不能声明默认构造函数（没有参数的构造函数）或析构函数。</li>
<li>结构是值类型，而类是引用类型。</li>
<li>实例化结构体时可以不使用new运算符。</li>
<li>结构类型是不可抽象、隐式密封的，故不能使用abstract和sealed修饰符。</li>
<li>在结构中声明字段时，字段无法被初始化，除非字段加上关键字const或static。</li>
<li>一个结构不能从另一个结构或类继承，而且不能作为一个类的基。所有结构都直接继承自 System.ValueType，后者继承自 System.Object。</li>
<li>结构在赋值时进行复制。将结构赋值给新变量时，将复制所有数据，并且对新副本所做的任何修改不会更改原始副本的数据。 不过结构仍然可以使用ref和out参数引用的方式传值给函数成员。另，在使用值类型的集合（如 Dictionary&lt;string, myStruct&gt;）时，请务必记住这一点。</li></ul>
<p><strong>2.结构体声明</strong></p>
<div>
<div>
<pre class="prettyprint linenums">    //结构体的声明<br />
    public struct Rectangle<br />
    {<br />
        public double x,y;<br />
        public static double z = 5;//结构体里的字段只有加上static或者const关键字才能被初始化

        //结构体里的构造函数必须是带参数的<br />
        public Rectangle(double x1, double y1)<br />
        {<br />
            x= x1;<br />
            y= y1;<br />
            Console.WriteLine(x.ToString()+" "+y.ToString());<br />
        }<br />
    }

    class Prgram1<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            //结构体的初始化<br />
            Rectangle rect1;<br />
            Rectangle rect2 = new Rectangle();<br />
            Rectangle rect3 = new Rectangle(5, 5);

            //输出各个的值<br />
            Console.Write("rect1:");<br />
            Console.WriteLine("x = {0}, y = {1}", rect1.x, rect1.y);

            Console.Write("rect2:");<br />
            Console.WriteLine("x = {0}, y = {1}", rect2.x, rect2.y);

            Console.Write("rect3:");<br />
            Console.WriteLine("x = {0}, y = {1}", rect3.x, rect3.y);

        }<br />
    }

    /* 输出:<br />
    rect1: x = 0, y = 0<br />
    rect2: x = 0, y = 0<br />
    rect3: x = 5, y = 5<br />
    */</pre>
</div>
<p>示例1</p></div>
<p><strong>3.结构体赋值</strong></p>
<p>由于结构体是值类型，故将一个结构体赋给新变量时，同时将复制它的所有数据，但是对新副本所做的修改不会影响原结构体。简单的说就是赋值时只复制值不复制地址。示例如下:</p>
<div>
<div>
<pre class="prettyprint linenums">    class Prgram2<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            Rectangle rect = new Rectangle(10, 10);<br />
            Rectangle rect1 = rect;<br />
            rect1.width = 5;<br />
            rect1.length = 5;

            Console.Write("rect:");<br />
            Console.WriteLine("x={0},y={1}",rect.length,rect.width);

            Console.Write("rect1:");<br />
            Console.WriteLine("x={0},y={1}", rect1.length, rect1.width);<br />
        }<br />
    }<br />
    /* 输出:<br />
    rect: x = 10, y = 10<br />
    rect1: x = 5, y = 5<br />
    */</pre>
</div>
<p>示例2</p></div>
<p>但在这里我有过小小的疑问，MSDN中在说到结构体的赋值时提到：&ldquo;<!--?XML:NAMESPACE PREFIX = "[default] http://www.w3.org/1999/xhtml" NS = "http://www.w3.org/1999/xhtml" /-->结构可用作可以为 null 的类型，因而可向其赋 null 值&rdquo;，这句话有点饶，乍一看就想一个值类型怎么能赋空值呢。后来仔细看了一下这句话提到的&ldquo;可以为null的类型&rdquo;，才发现它指的是Nullable结构即可空类型，这下明白了。对于值类型如果要赋空值，可以使用Nullable结构。用法就是Nullable&lt;Rectangle&gt;或者更方便的Rectangle?，关于可空类型园子里讲的很多，这里就不多说了。</p>
<p><strong>4.结构体的装箱拆箱</strong></p>
<p>大家都知道，装箱就是值类型到引用类型转变的过程，拆箱就是引用类型到值类型转变的过程。对于结构体来说当然也是这样，当一个结构体转换成Object或者它所继承的接口类型时，就是装箱，反之则是拆箱。值得一提的是，当我们把结构体转换后，再次改变结构体的值，转换成的引用对象的值是不变的，因为转变过后该引用对象就是不再是原来的值对象了。示例如下：</p>
<div>
<div>
<pre class="prettyprint linenums">    interface IPolygon<br />
    {<br />
        int EdgeNum { get; set; }<br />
    }

    public struct Rectangle : IPolygon<br />
    {<br />
        private int edgenum;<br />
        public int EdgeNum<br />
        {<br />
            get { return edgenum; }<br />
            set { edgenum = value; }<br />
        }<br />
    }

    class Prgram3<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            Rectangle rect = new Rectangle();<br />
            rect.EdgeNum = 4;<br />
            Console.WriteLine("rect.EdgeNum={0}", rect.EdgeNum);//4

            //隐式装箱为接口类型<br />
            IPolygon polygon = rect as IPolygon;<br />
            polygon.EdgeNum = 8;<br />
            Console.WriteLine("Changed interface.");<br />
            Console.WriteLine("polygon.EdgeNum={0},rect.EdgeNum={1}",polygon.EdgeNum,rect.EdgeNum);//8,4

            //改变结构体的值再输出<br />
            rect.EdgeNum = 5;<br />
            Console.WriteLine("Changed Struct.");<br />
            Console.WriteLine("polygon.EdgeNum={0},rect.EdgeNum={1}", polygon.EdgeNum, rect.EdgeNum);//8,5<br />
        }<br />
    }</pre>
</div>
<p>示例3</p></div>
<p><strong>5.结构体的构造函数</strong></p>
<p>关于结构体的构造函数，有以下几点需要知道：</p>
<p>当结构包含引用类型作为成员时，必须显式调用该成员的默认构造函数，否则该成员将保持未赋值状态且该结构不可用。</p>
<p>当我们声明一个结构体时，编译器会自动为其生成一个隐含的构造函数，该构造函数会将结构体中的每个字段初始化为默认值表中显示的默认值，而这个构造函数是不允许被替换的，故结构体不能自定义无参的构造函数。</p>
<p><!--?XML:NAMESPACE PREFIX = "[default] http://www.w3.org/1999/xhtml" NS = "http://www.w3.org/1999/xhtml" /-->当结构体中含有私有成员或以其他方式设置的不可访问成员时，这些成员只能在有参构造函数中进行初始化。并且当定义有参构造函数时，一定要完成所有字段的初始化，如果没有完成所有字段的初始化，编译时会发生错误。</p>
<p>结构体可以使用静态的构造函数，其使用方法与类的静态构造函数相类似。当结构体的第一个实例成员或静态成员或显示声明的构造函数被调用前，静态构造函数会被调用，且在整个过程中只被调用一次。</p>
<div>
<div>
<pre class="prettyprint linenums">    public struct Rectangle<br />
    {<br />
        public double x,y;<br />
        public static int edgeNum;

        static Rectangle()<br />
        {<br />
            Console.WriteLine("The static constructor invoked");<br />
        }

        public void Test()<br />
        {<br />
            Console.WriteLine("The Test function invoked");<br />
        }

        public Rectangle(double x1,double y1)<br />
        {<br />
            x = x1;<br />
            y = y1;<br />
        }<br />
    }

    class Prgram4<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            Rectangle.edgeNum = 4;<br />
            Console.WriteLine("Rectangle.edgeNum = {0}", Rectangle.edgeNum);

            Rectangle rect = new Rectangle(5, 5);<br />
            Console.WriteLine("rect.x={0},rect.y={0}", rect.x, rect.y);

            Rectangle rect1=new Rectangle ();<br />
            rect1.Test();

            Console.Read();<br />
        }<br />
    }

    //上面三种都可以触发静态构造函数，但只会出现一次"The static constructor invoked"</pre>
</div>
<p>示例4</p></div>
<p><strong>6.结构体的多态和继承</strong></p>
<p>结构体并不像类那样存在继承，它是隐式密封的，它可以实现接口但不能指定基类，并且由于这个特性它的成员的声明不能加protected和internal关键字。</p>
<p>结构体的成员不能是abstract或者virtual,因而voerride修饰符只适用于重写从System.ValueType继承的方法。</p>
<p>关于结构体为什么是不可继承的，下面这段话解释的很好：</p>
<blockquote><p><strong>为什么设计编程语言时将结构设计成无继承性？&shy;</strong><br />其实类的继承是有相当的成本的 &mdash;&mdash;由于继承性，每个类需要用额外的数据空间来存储&ldquo;继承图&rdquo;来表示类的传承历史，<br />通俗地说来就是我们人类的家族家谱，里面存储着我们的祖宗十八代，只有这样我们才知道我们从哪里来的，而家谱肯定是需要额外的空间来存放的。<br />大家不要觉得这个存放&ldquo;继承图&rdquo;的空间很小，如果我们的程序需要用10000个点(Point)来存放游戏中的人物形体数据的话，<br />在一个场景中又有N个人，这个内存开销可不是小数目了。所以我们可以通过将点(Point)申明成 Struct而不是class来节约内存空间。</p></blockquote>
<p><strong>7.结构体的适用场合</strong></p>
<p>结构体适合一些小的数据结构，如Point、Rectangle、Color等，如果它们使用类类型的话，为了引用每个对象，则需分配更多内存；这种情况下，使用结构可以节约资源。或者如果确定数据结构不会用到一些面向对象的特性，那么结构体与类相比是个更好的选择。</p>
<p>--------------------------------------------分----------------割--------------线---------------------------------------------------</p>
<p>本文算是梳理了C#中有关结构体的基础知识，虽然写了不少，可基本上没有涉及到更深，像一些更底层的东西都没有说到。而且由于技术有限难免有所疏漏错误，如果您看出来请不吝指出，谢谢。</p>
<p>本文参考学习自以下地址，谢谢原作者们的贡献：</p>
<p><a href="https://msdn.microsoft.com/zh-cn/library/0taef578.aspx" rel="external nofollow noreferrer">MSDN-使用结构</a></p>
<p><a href="http://www.cnblogs.com/jiajiayuan/archive/2011/09/20/2181582.html" rel="external nofollow noreferrer">C#之结构</a></p>
<p><a href="http://www.cnblogs.com/kissdodog/archive/2013/05/11/3072832.html" rel="external nofollow noreferrer">C# 结构体 struct</a></p>
<p><a href="http://blog.163.com/jong_cai/blog/static/8702804520091129111125531/" rel="external nofollow noreferrer">C# - 结构体转换为接口引用时隐式装箱的影响</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o15n5q.html">Step by step 如何创建一个新森林</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zy26v9.html">搭建Spark的单机版集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2dmw8.html">用php脚本给html中引用的js和css路径打上版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwjgdq.html">打磨程序员的专属利器&mdash;&mdash;命令行&amp;amp&semi;界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgj3r9.html">iOS用ASIHttpRequest上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6x3p8.html">ASP&period;NET中的KRE是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0xnd8.html">从源码看java中Integer的缓存问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vydw48.html">MockMvc和Mockito之酷炫使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvknloq.html">HDU 1068 Girls and Boys &lpar;二分图最大独立集&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvjnz1q.html">实现cookie跨域访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5wnn8.html">用urlencode&lpar;String str&rpar;对URL传递参数进行编码，提高安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmrp79.html">Qt使用中碰到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg12je8.html">Spring学习（4）---Bean基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6el38.html">【深度学习系列】一起来参加百度 PaddlePaddle AI 大赛吧！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjexpg8.html">Activity和Window的View的移动的一些思考与体会，腾讯悬浮小火箭的实现策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrpd69.html">Java KeyStore 用命令生成keystore文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wydzzq.html">UVa442 Matrix Chain Multiplication&lpar;栈&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx1geq.html">搭建前端监控系统（三）NodeJs服务器部署篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vgz0q.html">mysql中delete from in子查询删除失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10yp1q.html">Linux基础命令---杀死进程killall</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xe5ne8.html">Web之CSS开发技巧&colon;  CSS &commat;media</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oejm49.html">将日志写入Debug窗口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm4epe9.html">模拟springmvc 内部登陆，跳过spring filter</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oej4v9.html">nginx配置记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2dk38.html">VHDL学习之TEXTIO在仿真中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1w1dd9.html">使用&lowbar;&lowbar;autoload&lpar;&rpar;来管理文件导入</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjrw3y9.html">Boost 和 STL 相比有哪些优势和劣势？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde2wzv9.html">用Setup系列函数完成驱动卸载安装&lbrack;驱动安装卸载程序&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j03myeq.html">linux下编译eXosip、osip，以及UAC和UAS的例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm4oxe9.html">HDU3727--Jewel  &lpar;主席树 静态区间第k大&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
